%define anolis_release 1

%bcond_without hardware

%global with_vulkan_hw 1
%global with_vdpau 1
%global with_va 1
%global base_vulkan ,amd

%ifarch x86_64
%global with_crocus 1
%global with_i915   1
%global with_iris   1
%global with_xa     1
%global platform_vulkan ,intel,intel_hasvk
%endif

%ifarch aarch64
%global with_freedreno 1
%global with_kmsro     1
%global with_panfrost  1
%global with_tegra     1
%global with_xa        1
%global platform_vulkan ,broadcom,freedreno,panfrost
%endif

%global with_radeonsi 1
%global with_vmware 1

%bcond_without valgrind

%global vulkan_drivers swrast%{?base_vulkan}%{?platform_vulkan}

Name:          mesa
Summary:       Mesa graphics libraries
Version:       23.1.8
Release:       %{anolis_release}%{?dist}
License:       MIT
URL:           http://www.mesa3d.org
Source0:       https://archive.mesa3d.org/mesa-%{version}.tar.xz

BuildRequires: gcc, gcc-c++, gettext, meson >= 1.0.0
%if %{with hardware}
BuildRequires: kernel-headers
%endif
BuildRequires: pkgconfig(libdrm) >= 2.4.109, pkgconfig(zlib) >= 1.2.3
BuildRequires: pkgconfig(expat), pkgconfig(libselinux), pkgconfig(x11)
BuildRequires: pkgconfig(wayland-scanner) >= 1.15, pkgconfig(wayland-protocols) >= 1.24
BuildRequires: pkgconfig(wayland-client) >= 1.18, pkgconfig(wayland-server) >= 1.18
BuildRequires: pkgconfig(wayland-egl-backend) >= 3, pkgconfig(xdamage) >= 1.1
BuildRequires: pkgconfig(xext), pkgconfig(xxf86vm), pkgconfig(xcb), pkgconfig(x11-xcb)
BuildRequires: pkgconfig(xfixes) >= 2.0, pkgconfig(xcb-glx) >= 1.8.1
BuildRequires: pkgconfig(xcb-dri2) >= 1.8, pkgconfig(xcb-dri3), pkgconfig(xcb-present)
BuildRequires: pkgconfig(xcb-sync), pkgconfig(xshmfence) >= 1.1, pkgconfig(dri2proto) >= 2.8
BuildRequires: pkgconfig(glproto) >= 1.4.14, pkgconfig(xrandr) >= 1.3
BuildRequires: pkgconfig(xcb-xfixes), pkgconfig(xcb-randr), pkgconfig(libunwind)
BuildRequires: pkgconfig(libzstd), pkgconfig(libudev)
BuildRequires: lm_sensors-devel, bison, flex
BuildRequires: pkgconfig(libelf), pkgconfig(libglvnd) >= 1.3.2, llvm-devel >= 7.0.0
BuildRequires: python3-devel, python3-mako, vulkan-headers, glslang
%if 0%{?with_vdpau}
BuildRequires: pkgconfig(vdpau) >= 1.1
%endif
%if 0%{?with_va}
BuildRequires: pkgconfig(libva) >= 0.38.0
%endif
%if 0%{?with_omx}
BuildRequires: pkgconfig(libomxil-bellagio)
%endif
%if 0%{?with_opencl}
BuildRequires: clang-devel, bindgen, rust-packaging
BuildRequires: pkgconfig(libclc)
BuildRequires: pkgconfig(SPIRV-Tools)
BuildRequires: pkgconfig(LLVMSPIRVLib)
%endif
%if %{with valgrind}
BuildRequires: pkgconfig(valgrind)
%endif
%if 0%{?with_vulkan_hw}
BuildRequires: pkgconfig(vulkan)
%endif

%description
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.

%package filesystem
Summary:       Mesa driver filesystem
Provides:      mesa-dri-filesystem = %{EVR}
Obsoletes:     mesa-dri-filesystem < %{EVR}

%description filesystem
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.

%package libGL
Summary:       Mesa libGL runtime libraries
Requires:      %{name}-libglapi = %{EVR}
Requires:      libglvnd-glx >= 1:1.3.2

%description libGL
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.

%package libGL-devel
Summary:       Mesa libGL development package
Requires:      %{name}-libGL = %{EVR}
Requires:      libglvnd-devel >= 1:1.3.2
Provides:      libGL-devel
Recommends:    gl-manpages

%description libGL-devel
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.

%package libEGL
Summary:       Mesa libEGL runtime libraries
Requires:      libglvnd-egl >= 1:1.3.2

%description libEGL
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.

%package libEGL-devel
Summary:       Mesa libEGL development package
Requires:      %{name}-libEGL = %{EVR}
Requires:      libglvnd-devel >= 1:1.3.2
Requires:      %{name}-khr-devel
Provides:      libEGL-devel

%description libEGL-devel
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.

%package dri-drivers
Summary:       Mesa-based DRI drivers
Requires:      %{name}-filesystem = %{EVR}
%if 0%{?with_va}
Recommends:    %{name}-va-drivers = %{EVR}
%endif

%description dri-drivers
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.

%if 0%{?with_omx}
%package omx-drivers
Summary:       Mesa-based OMX drivers
Requires:      %{name}-filesystem = %{EVR}

%description omx-drivers
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.
%endif

%if 0%{?with_va}
%package va-drivers
Summary:       Mesa-based VA-API video acceleration drivers
Requires:      %{name}-filesystem = %{EVR}
Obsoletes:     %{name}-vaapi-drivers < 22.2.0-5
Conflicts:     %{name}-dri-drivers < 22.3.0
 
%description va-drivers
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.
%endif

%if 0%{?with_vdpau}
%package vdpau-drivers
Summary:       Mesa-based VDPAU drivers
Requires:      %{name}-filesystem = %{EVR}

%description vdpau-drivers
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.
%endif

%package libOSMesa
Summary:       Mesa offscreen rendering libraries
Requires:      %{name}-libglapi = %{EVR}
Provides:      libOSMesa

%description libOSMesa
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.

%package libOSMesa-devel
Summary:       Mesa offscreen rendering development package
Requires:      %{name}-libOSMesa = %{EVR}

%description libOSMesa-devel
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.

%package libgbm
Summary:       Mesa gbm runtime library
Provides:      libgbm

%description libgbm
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.

%package libgbm-devel
Summary:       Mesa libgbm development package
Requires:      %{name}-libgbm = %{EVR}
Provides:      libgbm-devel

%description libgbm-devel
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.

%if 0%{?with_xa}
%package libxatracker
Summary:       Mesa XA state tracker
Provides:      libxatracker

%description libxatracker
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.

%package libxatracker-devel
Summary:       Mesa XA state tracker development package
Requires:      %{name}-libxatracker = %{EVR}
Provides:      libxatracker-devel

%description libxatracker-devel
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.
%endif

%package libglapi
Summary:       Mesa shared glapi
Provides:      libglapi

%description libglapi
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.

%if 0%{?with_opencl}
%package libOpenCL
Summary:       Mesa OpenCL runtime library
Requires:      ocl-icd, libclc, opencl-filesystem
Requires:      %{name}-libgbm = %{EVR}
Requires:      spirv-tools-libs = %{installed_version_of spirv-tools-libs}

%description libOpenCL
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.

%package libOpenCL-devel
Summary:       Mesa OpenCL development package
Requires:      %{name}-libOpenCL = %{EVR}

%description libOpenCL-devel
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.
%endif

%if 0%{?with_nine}
%package libd3d
Summary:       Mesa Direct3D9 state tracker

%description libd3d
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.

%package libd3d-devel
Summary:       Mesa Direct3D9 state tracker development package
Requires:      %{name}-libd3d = %{EVR}

%description libd3d-devel
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

%{summary}.
%endif

%package vulkan-drivers
Summary:       Mesa Vulkan drivers
Requires:      vulkan
Obsoletes:     mesa-vulkan-devel < %{EVR}

%description vulkan-drivers
The Mesa project began as an open-source implementation of the OpenGL specification - a system
for rendering interactive 3D graphics. Over the years the project has grown to implement more
graphics APIs, including OpenGL ES, OpenCL, OpenMAX, VDPAU, VA-API, Vulkan and EGL.A variety of
device drivers allows the Mesa libraries to be used in many different environments ranging from
software emulation to complete hardware acceleration for modern GPUs. Mesa ties into several other
open-source projects: the Direct Rendering Infrastructure, X.org, and Wayland to provide OpenGL
support on Linux, FreeBSD, and other operating systems.

The drivers with support for the Vulkan API.

%prep
%autosetup -n %{name}-%{version} -p1

%build
# Disable LTO for now
%define _lto_cflags %{nil}

%meson \
  -Dplatforms=x11,wayland \
  -Dandroid-libbacktrace=disabled \
  -Ddri3=enabled \
  -Dosmesa=true \
%if %{with hardware}
  -Dgallium-drivers=swrast,virgl,nouveau%{?with_r300:,r300}%{?with_crocus:,crocus}%{?with_i915:,i915}%{?with_iris:,iris}%{?with_vmware:,svga}%{?with_radeonsi:,radeonsi}%{?with_r600:,r600}%{?with_freedreno:,freedreno}%{?with_etnaviv:,etnaviv}%{?with_tegra:,tegra}%{?with_vc4:,vc4}%{?with_v3d:,v3d}%{?with_kmsro:,kmsro}%{?with_lima:,lima}%{?with_panfrost:,panfrost}%{?with_vulkan_hw:,zink} \
%else
  -Dgallium-drivers=swrast,virgl \
%endif
  -Dgallium-vdpau=%{?with_vdpau:enabled}%{!?with_vdpau:disabled} \
  -Dgallium-omx=%{?with_omx:bellagio}%{!?with_omx:disabled} \
  -Dgallium-va=%{?with_va:enabled}%{!?with_va:disabled} \
  -Dgallium-xa=%{?with_xa:enabled}%{!?with_xa:disabled} \
  -Dgallium-nine=%{?with_nine:true}%{!?with_nine:false} \
  -Dgallium-opencl=%{?with_opencl:icd}%{!?with_opencl:disabled} \
  -Dvulkan-drivers=%{?vulkan_drivers} \
  -Dvulkan-layers=device-select \
  -Dshared-glapi=enabled \
  -Dgles1=disabled \
  -Dgles2=enabled \
  -Dopengl=true \
  -Dgbm=enabled \
  -Dglx=dri \
  -Degl=enabled \
  -Dglvnd=true \
  -Dmicrosoft-clc=disabled \
  -Dllvm=enabled \
  -Dshared-llvm=enabled \
  -Dvalgrind=%{?with_valgrind:enabled}%{!?with_valgrind:disabled} \
  -Dbuild-tests=false \
  -Dselinux=true \
  %{nil}
%meson_build

%install
%meson_install

# libvdpau opens the versioned name, don't bother including the unversioned
rm -vf %{buildroot}%{_libdir}/vdpau/*.so
# likewise glvnd
rm -vf %{buildroot}%{_libdir}/libGLX_mesa.so
rm -vf %{buildroot}%{_libdir}/libEGL_mesa.so
# XXX can we just not build this
rm -vf %{buildroot}%{_libdir}/libGLES*

# glvnd needs a default provider for indirect rendering where it cannot determine the vendor
ln -s %{_libdir}/libGLX_mesa.so.0 %{buildroot}%{_libdir}/libGLX_system.so.0

# generate abi/api files for so or bin, see more in:
# https://open.gitcode.host/docs/articles/305-module-and-checklist-of-spec
%generate_compatibility_deps

%files filesystem
%dir %{_libdir}/dri
%if %{with hardware}
%if 0%{?with_vdpau}
%dir %{_libdir}/vdpau
%endif
%endif

%files libGL
%dir %{abidir}
%{_libdir}/libGLX_mesa.so.0*
%{_libdir}/libGLX_system.so.0*
%{abidir}/libGLX*.dump

%files libGL-devel
%dir %{_includedir}/GL/internal
%{_includedir}/GL/internal/dri_interface.h
%{_libdir}/pkgconfig/dri.pc
%{_libdir}/libglapi.so

%files libEGL
%{_datadir}/glvnd/egl_vendor.d/50_mesa.json
%{_libdir}/libEGL_mesa.so.0*
%{abidir}/libEGL_mesa*.dump

%files libEGL-devel
%dir %{_includedir}/EGL
%{_includedir}/EGL/eglext_angle.h
%{_includedir}/EGL/eglmesaext.h

%files libglapi
%{_libdir}/libglapi.so.0
%{_libdir}/libglapi.so.0.*
%{abidir}/libglapi*.dump

%files libOSMesa
%{_libdir}/libOSMesa.so.8*
%{abidir}/libOSMesa*.dump

%files libOSMesa-devel
%dir %{_includedir}/GL
%{_includedir}/GL/osmesa.h
%{_libdir}/libOSMesa.so
%{_libdir}/pkgconfig/osmesa.pc

%files libgbm
%{_libdir}/libgbm.so.1
%{_libdir}/libgbm.so.1.*
%{abidir}/libgbm*.dump

%files libgbm-devel
%{_libdir}/libgbm.so
%{_includedir}/gbm.h
%{_libdir}/pkgconfig/gbm.pc

%if 0%{?with_xa}
%files libxatracker
%if %{with hardware}
%{_libdir}/libxatracker.so.2
%{_libdir}/libxatracker.so.2.*
%{abidir}/libxatracker*.dump
%endif

%files libxatracker-devel
%if %{with hardware}
%{_libdir}/libxatracker.so
%{_includedir}/xa_tracker.h
%{_includedir}/xa_composite.h
%{_includedir}/xa_context.h
%{_libdir}/pkgconfig/xatracker.pc
%endif
%endif

%if 0%{?with_opencl}
%files libOpenCL
%{_libdir}/libMesaOpenCL.so.*
%{abidir}/libMesaOpenCL*.dump
%{_sysconfdir}/OpenCL/vendors/mesa.icd

%files libOpenCL-devel
%{_libdir}/libMesaOpenCL.so
%endif

%if 0%{?with_nine}
%files libd3d
%dir %{_libdir}/d3d/
%{_libdir}/d3d/*.so.*

%files libd3d-devel
%{_libdir}/pkgconfig/d3d.pc
%{_includedir}/d3dadapter/
%{_libdir}/d3d/*.so
%endif

%files dri-drivers
%dir %{_datadir}/drirc.d
%{_datadir}/drirc.d/00-mesa-defaults.conf
%{_libdir}/dri/kms_swrast_dri.so
%{_libdir}/dri/swrast_dri.so
%{_libdir}/dri/virtio_gpu_dri.so
%{abidir}/kms_swrast_dri.dump
%{abidir}/swrast_dri.dump
%{abidir}/virtio_gpu_dri.dump

%if %{with hardware}
%if 0%{?with_r300}
%{_libdir}/dri/r300_dri.so
%endif
%if 0%{?with_radeonsi}
%if 0%{?with_r600}
%{_libdir}/dri/r600_dri.so
%endif
%{_libdir}/dri/radeonsi_dri.so
%{abidir}/radeonsi_dri.dump
%endif
%ifarch x86_64
%{_libdir}/dri/crocus_dri.so
%{_libdir}/dri/i915_dri.so
%{_libdir}/dri/iris_dri.so
%{abidir}/crocus_dri.dump
%{abidir}/i915_dri.dump
%{abidir}/iris_dri.dump
%endif
%ifarch aarch64
%{_libdir}/dri/ingenic-drm_dri.so
%{_libdir}/dri/imx-drm_dri.so
%{_libdir}/dri/imx-lcdif_dri.so
%{_libdir}/dri/kirin_dri.so
%{_libdir}/dri/komeda_dri.so
%{_libdir}/dri/mali-dp_dri.so
%{_libdir}/dri/mcde_dri.so
%{_libdir}/dri/mxsfb-drm_dri.so
%{_libdir}/dri/rcar-du_dri.so
%{_libdir}/dri/stm_dri.so
%{abidir}/ingenic-drm_dri.dump
%{abidir}/imx-drm_dri.dump
%{abidir}/imx-lcdif_dri.dump
%{abidir}/kirin_dri.dump
%{abidir}/komeda_dri.dump
%{abidir}/mali-dp_dri.dump
%{abidir}/mcde_dri.dump
%{abidir}/mxsfb-drm_dri.dump
%{abidir}/rcar-du_dri.dump
%{abidir}/stm_dri.dump
%endif
%if 0%{?with_vc4}
%{_libdir}/dri/vc4_dri.so
%{abidir}/vc4_dri.dump
%endif
%if 0%{?with_v3d}
%{_libdir}/dri/v3d_dri.so
%{abidir}/v3d_dri.dump
%endif
%if 0%{?with_freedreno}
%{_libdir}/dri/kgsl_dri.so
%{_libdir}/dri/msm_dri.so
%{abidir}/kgsl_dri.dump
%{abidir}/msm_dri.dump
%endif
%if 0%{?with_etnaviv}
%{_libdir}/dri/etnaviv_dri.so
%{abidir}/etnaviv_dri.dump
%endif
%if 0%{?with_tegra}
%{_libdir}/dri/tegra_dri.so
%{abidir}/tegra_dri.dump
%endif
%if 0%{?with_lima}
%{_libdir}/dri/lima_dri.so
%{abidir}/lima_dri.dump
%endif
%if 0%{?with_panfrost}
%{_libdir}/dri/panfrost_dri.so
%{abidir}/panfrost_dri.dump
%endif
%{_libdir}/dri/nouveau_dri.so
%{abidir}/nouveau_dri.dump
%if 0%{?with_vmware}
%{_libdir}/dri/vmwgfx_dri.so
%{abidir}/vmwgfx_dri.dump
%endif
%endif
%if 0%{?with_opencl}
%dir %{_libdir}/gallium-pipe
%{_libdir}/gallium-pipe/*.so
%endif
%if 0%{?with_kmsro}
%{_libdir}/dri/armada-drm_dri.so
%{_libdir}/dri/exynos_dri.so
%{_libdir}/dri/hx8357d_dri.so
%{_libdir}/dri/ili9225_dri.so
%{_libdir}/dri/ili9341_dri.so
%{_libdir}/dri/imx-dcss_dri.so
%{_libdir}/dri/mediatek_dri.so
%{_libdir}/dri/meson_dri.so
%{_libdir}/dri/mi0283qt_dri.so
%{_libdir}/dri/pl111_dri.so
%{_libdir}/dri/repaper_dri.so
%{_libdir}/dri/rockchip_dri.so
%{_libdir}/dri/st7586_dri.so
%{_libdir}/dri/st7735r_dri.so
%{_libdir}/dri/sun4i-drm_dri.so
%{abidir}/armada-drm_dri.dump
%{abidir}/exynos_dri.dump
%{abidir}/hx8357d_dri.dump
%{abidir}/ili9225_dri.dump
%{abidir}/ili9341_dri.dump
%{abidir}/imx-dcss_dri.dump
%{abidir}/mediatek_dri.dump
%{abidir}/meson_dri.dump
%{abidir}/mi0283qt_dri.dump
%{abidir}/pl111_dri.dump
%{abidir}/repaper_dri.dump
%{abidir}/rockchip_dri.dump
%{abidir}/st7586_dri.dump
%{abidir}/st7735r_dri.dump
%{abidir}/sun4i-drm_dri.dump
%endif
%if 0%{?with_vulkan_hw}
%{_libdir}/dri/zink_dri.so
%{abidir}/zink_dri.dump
%endif

%if 0%{?with_omx}
%files omx-drivers
%{_libdir}/bellagio/libomx_mesa.so
%endif

%if 0%{?with_va}
%files va-drivers
%{_libdir}/dri/nouveau_drv_video.so
%{abidir}/nouveau_drv_video.dump
%if 0%{?with_r600}
%{_libdir}/dri/r600_drv_video.so
%endif
%if 0%{?with_radeonsi}
%{_libdir}/dri/radeonsi_drv_video.so
%{abidir}/radeonsi_drv_video.dump
%endif
%{_libdir}/dri/virtio_gpu_drv_video.so
%{abidir}/virtio_gpu_drv_video.dump
%endif

%if 0%{?with_vdpau}
%files vdpau-drivers
%{_libdir}/vdpau/libvdpau_nouveau.so.1*
%{abidir}/libvdpau*.dump
%if 0%{?with_r300}
%{_libdir}/vdpau/libvdpau_r300.so.1*
%endif
%if 0%{?with_r600}
%{_libdir}/vdpau/libvdpau_r600.so.1*
%endif
%if 0%{?with_radeonsi}
%{_libdir}/vdpau/libvdpau_radeonsi.so.1*
%endif
%{_libdir}/vdpau/libvdpau_virtio_gpu.so.1*
%endif

%files vulkan-drivers
%{_libdir}/libvulkan_lvp.so
%{_datadir}/vulkan/icd.d/lvp_icd.*.json
%{_libdir}/libVkLayer_MESA_device_select.so
%{abidir}/libvulkan_lvp.dump
%{abidir}/libVkLayer_MESA_device_select.dump
%{_datadir}/vulkan/implicit_layer.d/VkLayer_MESA_device_select.json
%if 0%{?with_vulkan_hw}
%{_libdir}/libvulkan_radeon.so
%{abidir}/libvulkan_radeon.dump
%{_datadir}/drirc.d/00-radv-defaults.conf
%{_datadir}/vulkan/icd.d/radeon_icd.*.json
%ifarch x86_64
%{_libdir}/libvulkan_intel.so
%{abidir}/libvulkan_intel.dump
%{_datadir}/vulkan/icd.d/intel_icd.*.json
%{_libdir}/libvulkan_intel_hasvk.so
%{abidir}/libvulkan_intel_hasvk.dump
%{_datadir}/vulkan/icd.d/intel_hasvk_icd.*.json
%endif
%ifarch aarch64
%{_libdir}/libvulkan_broadcom.so
%{_datadir}/vulkan/icd.d/broadcom_icd.*.json
%{_libdir}/libvulkan_freedreno.so
%{_datadir}/vulkan/icd.d/freedreno_icd.*.json
%{_libdir}/libvulkan_panfrost.so
%{abidir}/libvulkan_broadcom.dump
%{abidir}/libvulkan_freedreno.dump
%{abidir}/libvulkan_panfrost.dump
%{_datadir}/vulkan/icd.d/panfrost_icd.*.json
%endif
%endif

%changelog
* Wed Sep 27 2023 Funda Wang <fundawang@yeah.net> - 23.1.8-1
- New version 23.1.8

* Thu Sep 07 2023 Funda Wang <fundawang@yeah.net> - 23.1.7-1
- New version 23.1.7

* Tue Jul 11 2023 Funda Wang <fundawang@yeah.net> - 23.1.3-1
- New version 23.1.3

* Sun May 28 2023 Funda Wang <fundawang@yeah.net> - 23.1.1-1
- New version 23.1.1

* Mon May 22 2023 Funda Wang <fundawang@yeah.net> - 23.1.0-1
- New version 23.1.0

* Fri Apr 21 2023 Funda Wang <fundawang@yeah.net> - 23.0.3-1
- New version 23.0.3

* Sat Apr 15 2023 DengXiewei <dengxiewei@linux.alibaba.com> - 23.0.2-2
- Optimise spec

* Sat Apr 8 2023 Funda Wang <fundawang@yeah.net> - 23.0.2-1
- New version 23.0.2

* Fri Apr 7 2023 Funda Wang <fundawang@yeah.net> - 23.0.1-3
- Rebuild for new llvm

* Mon Mar 27 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 23.0.1-2
- Del Specific Fields

* Sat Mar 25 2023 Funda Wang <fundawang@yeah.net> - 23.0.1-1
- New version 23.0.1

* Sun Mar 12 2023 Funda Wang <fundawang@yeah.net> - 23.0.0-2
- Add versioned requirement for opencl

* Fri Feb 24 2023 Funda Wang <fundawang@yeah.net> - 23.0.0-1
- New version 23.0.0

* Mon Feb 13 2023 Funda Wang <fundawang@yeah.net> - 22.3.5-2
- Rebuild for llvm 15
 
* Thu Feb 9 2023 Funda Wang <fundawang@yeah.net> - 22.3.5-1
- New version 22.3.5

* Fri Jan 27 2023 Funda Wang <fundawang@yeah.net> - 22.3.4-1
- New version 22.3.4

* Thu Jan 12 2023 Funda Wang <fundawang@yeah.net> - 22.3.3-1
- New version 22.3.3

* Fri Dec 30 2022 Funda Wang <fundawang@yeah.net> - 22.3.2-1
- New version 22.3.2

* Thu Dec 15 2022 Funda Wang <fundawang@yeah.net> - 22.3.1-1
- New version 22.3.1

* Thu Dec 1 2022 Funda Wang <fundawang@yeah.net> - 22.3.0-1
- New version 22.3.0

* Thu Nov 17 2022 Funda Wang <fundawang@yeah.net> - 22.2.4-1
- New version 22.2.4

* Tue Nov 8 2022 Funda Wang <fundawang@yeah.net> - 22.2.3-1
- New version 22.2.3

* Tue Oct 18 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 22.1.7-2
- optimise spec file

* Mon Sep 19 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 22.1.7-1
- Update to 22.1.7

* Sat May 7 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 22.0.1-3
- Bump version to rebuild with llvm-13

* Mon Apr 25 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 22.0.1-2
- remove isa from requires

* Fri Apr 15 2022 Yuanhong Peng <yummypeng@linux.alibaba.com> - 22.0.1-1
- Init package from upstream v22.0.1
